char rcsid_bi_create[] = "$Id: bi_create.c,v 1.3 1992/08/10 17:26:37 pjames Exp $";

#include "match.h"
#include "property.h"
#include "quota.h"
#include "structures.h"
#include "storage.h"
#include "utils.h"

Objid
create_object(const char *name, Objid parent, Objid owner)
{
    Object	*o, *p;
    Objid	oid;
    int		i, nprops;

    if (retrieve(owner)  &&  !decr_quota(owner))
	return NOTHING;

    o = new_object();
    oid = o->id;
    o->name = strdup(name);
    o->verbdefs = 0;
    o->propdefs = 0;
    o->flags = 0;

    /*
     * put new object in class hierarchy
     */
    o->parent = parent;
    o->child = o->sibling = NOTHING;
    LL_APPEND(parent, child, oid, sibling)

    /*
     * transfer ownership to player
     * if owner == NOTHING, make object own itself.
     */
    if (owner == NOTHING)
	o->owner = oid;
    else
	o->owner = owner;

    o->location = o->contents = o->next = NOTHING;
    if (nprops = count_properties(oid)) {
	/* If this newly-created object has properties, then it must
	   have a valid parent. */
	p = retrieve(parent);
	o->propval = (Pval *) mymalloc(nprops * sizeof(Pval), M_PVAL);
	for (i = 0; i < nprops; i++) {
	    (o->propval)[i] = (p->propval)[i];
	    (o->propval)[i].var = vardup((o->propval)[i].var);
	    if ((o->propval)[i].perms & (1<<PP_CHOWN)) {
		(o->propval)[i].owner = o->owner;
	    }
	}
    } else {
	o->propval = 0;
    }
    return o->id;
}

/* $Log: bi_create.c,v $
 * Revision 1.3  1992/08/10  17:26:37  pjames
 * Updated #includes.
 *
 * Revision 1.2  1992/07/20  23:55:52  pavel
 * Added rcsid_<filename-root> declaration to hold the RCS ident. string.
 *
 * Revision 1.1  1992/07/20  23:23:12  pavel
 * Initial RCS-controlled version.
 * */
