char rcsid_quota[] = "$Id: quota.c,v 1.3 1992/08/10 16:54:57 pjames Exp $";

#include "quota.h"
#include "match.h"
#include "storage.h"
#include "structures.h"
#include "utils.h"

static const char	*quota_name = "ownership_quota";

int
decr_quota(Objid player)
{
    int		pid;
    Var		v;

    if (!match_property(quota_name, player, &pid))
	return 1;

    v = retrieve(player)->propval[pid].var;

    if (v.type != TYPE_NUM)
	return 1;

    if (v.v.num <= 0)
	return 0;

    retrieve(player)->propval[pid].var.v.num = v.v.num - 1;
    return 1;
}

void
incr_quota(Objid player)
{
    int		pid;
    Var		v;

    if (!retrieve(player)
	|| !match_property(quota_name, player, &pid))
	return;

    v = retrieve(player)->propval[pid].var;

    if (v.type != TYPE_NUM)
	return;

    retrieve(player)->propval[pid].var.v.num = v.v.num + 1;
}


/* $Log: quota.c,v $
 * Revision 1.3  1992/08/10  16:54:57  pjames
 * Updated #includes.
 *
 * Revision 1.2  1992/07/21  00:06:18  pavel
 * Added rcsid_<filename-root> declaration to hold the RCS ident. string.
 *
 * Revision 1.1  1992/07/20  23:23:12  pavel
 * Initial RCS-controlled version.
 * */
