#ifndef Storage_h
#define Storage_h 1

#include "my-stdio.h"
#include "structures.h"

typedef enum Memory_Type {
    M_AST_POOL, M_AST, M_PROGRAM, M_PVAL, M_NETWORK, M_STRING, M_VERBDEF,
    M_LIST, M_PREP, M_PROPDEF, M_OBJECT_TABLE, M_OBJECT,
    M_STREAM, M_NAMES, M_ENV, M_PI, M_TASK,

    M_BYTECODES, M_FORK_VECTORS, M_LIT_LIST,
    M_BYTECODE_LIST, M_BYTECODE_INFO, M_VL_VALUE, M_VL_LIST,
    M_LITERALS, M_EXPR_STACK, M_COND_ARM_STACK, M_STMT_STACK,

    M_RT_STACK, M_RT_ENV, M_BI_FUNC_DATA, M_VM,

    Sizeof_Memory_Type

} Memory_Type;

extern Var	players_list;

extern int	db_write(FILE *f);
extern void	db_printf(const char *format, ...);
extern int	db_read(FILE *f);

extern void	write_string(const char *);
extern const char *read_string(FILE *);
extern void	write_var(Var);
extern Var	read_var(FILE *);

extern void	write_program(Program *);
extern void	write_forked_program(Program *, unsigned f_index);
extern int	read_program(FILE *, Program **);

extern int	is_wizard(Objid oid);
extern int	is_programmer(Objid oid);
extern int	is_player(Objid oid);

extern Object  *new_object(void);
extern void 	free_object(Objid);

extern Object  *retrieve(Objid);
extern Objid	renumber_object(Objid);
extern char    *strdup(const char *);
extern int	db_size(void);
extern void	reset_db_size(void);
extern Var	memory_usage(void);

extern void	myfree(void *where, Memory_Type type);
extern void    *mymalloc(unsigned size, Memory_Type type);

#endif /* Storage_h */

/* $Log: storage.h,v $
 * Revision 1.1  1992/08/10  16:20:00  pjames
 * Initial RCS-controlled version
 *
   */
