#ifndef Sym_Table_h
#define Sym_Table_h 1

#include "my-stdio.h"

#include "structures.h"

struct Names {
    unsigned	max_size;
    unsigned	size;
    char      **names;
};

struct Env {
    unsigned	size;
    Var		vars[1];
};

extern Names   *new_names(unsigned max_size);
extern Names   *new_builtin_names(void);
extern Names   *copy_names(Names *);
extern unsigned	find_or_add_name(Names **, char *);
extern int	find_name(Names *, const char *);
extern void	free_names(Names *);

extern Env     *new_env(unsigned size);
extern Env     *copy_env(Env *);
extern void	free_env(Env *);
extern Var	env_ref(Env *, unsigned);
extern void	env_set(Env *, unsigned, Var);

extern void	write_env(FILE *, Names *, Env *);
extern int	read_env(FILE *, Names **, Env **);

/* Environment slots for built-in variables */
#define SLOT_NUM	0
#define SLOT_OBJ	1
#define SLOT_STR	2
#define SLOT_LIST	3
#define SLOT_ERR	4
#define SLOT_PLAYER	5
#define SLOT_THIS	6
#define SLOT_CALLER	7
#define SLOT_VERB	8
#define SLOT_ARGS	9
#define SLOT_ARGSTR	10
#define SLOT_DOBJ	11
#define SLOT_DOBJSTR	12
/* taken out to match code_elt.c #define SLOT_PREP	8 */
#define SLOT_PREPSTR	13
#define SLOT_IOBJ	14
#define SLOT_IOBJSTR	15

#define FIRST_USER_SLOT	16

#endif /* !Sym_Table_h */

/* $Log: sym_table.h,v $
 * Revision 1.1  1992/07/20  23:23:12  pavel
 * Initial RCS-controlled version.
 * */
