#ifndef Unparse_h
#define Unparse_h 1

#include "bytecodes.h"
#include "structures.h"   /* including Program */
#include "opcode.h"
#include "functions.h" /* name_func_by_num */
#include "my-stdio.h"
#include "my-string.h"
#include "parse_command.h" /* prep_name() */
#include "streams.h"

typedef void (*Unparser_Receiver)(void *, const char *);

/* the external functions */

#define MAIN_VECTOR -1 /* if f_index == MAIN_VECTOR, main_vector is used */
extern void 	list_prog(Program *, Unparser_Receiver, void *, 
			  char user_paren, char user_tab, int f_index);
extern unsigned	get_lineno(Program *, unsigned pc, int f_index);

extern char *err2str(enum error); /* E_NONE -> "E_NONE" */
extern const char *unparse_error(enum error errno); /* E_NONE -> "No error" */

extern const char *unparse_option(int);
extern const char *unparse_prep(int);

struct pptable_entry {
    const char         *name;
    Propid              propno;
    var_type	        type;     /* type of property */
    short               settable; /* by whom: 0 for program, 1 for wizard,
                                              2 for builder, 3 for player */
};

extern struct pptable_entry *match_pseudo_property(const char *, Propid *);

#endif

/* $Log: unparse.h,v $
 * Revision 1.3  1992/08/13  23:59:27  pavel
 * Converted to a typedef of `var_type' = `enum var_type'.
 *
 * Revision 1.2  1992/08/10  16:41:25  pjames
 * Changed ip to pc.
 *
 * Revision 1.1  1992/07/20  23:23:12  pavel
 * Initial RCS-controlled version.
 * */
