#ifndef Utils_h
#define Utils_h 1

#include "my-stdio.h"
#include "execute.h"

#ifdef STRCASE
extern int  strcasecmp(const char *, const char *);
extern int  strncasecmp(const char *, const char *, int);
#define mystrcasecmp(s1, s2)		strcasecmp(s1, s2)
#define mystrncasecmp(s1, s2, n)	strncasecmp(s1, s2, n)
#else
extern int	mystrcasecmp(const char *, const char *);
extern int	mystrncasecmp(const char *, const char *, int);
#endif

extern int	verbcasecmp(const char *verb, const char *word);

extern void	object_match_failed(Objid, Objid, const char *);

extern void	free_var(Var);
extern Var	vardup(Var);

extern int	compare_ints(int a, int b);
extern int	equality(Var lhs, Var rhs);
extern int	compare(Var lhs, Var rhs);
extern int 	is_true(Var v);

extern void	init_pi(Parse_Info *);
extern void	free_pi(Parse_Info *, int);
extern Parse_Info *copy_pi(Parse_Info *);
extern Parse_Info *new_pi(void);
extern void	write_activ_as_pi(activation);
extern void	write_pi(Parse_Info *);
extern int	read_activ_as_pi(FILE *, activation *);
extern int	read_pi(FILE *, Parse_Info **);

Objid		create_object(const char *name, Objid parent, Objid owner);

extern char    *strsub(const char *, const char *, const char *, int);
extern int	strindex(const char *, const char *, int);
extern int	strrindex(const char *, const char *, int);

extern Var	get_system_property(const char *);
extern Objid	get_system_object(const char *);

void 		write_rt_env(char **var_names, Var *rt_env, unsigned size);
int		read_rt_env(FILE *f, char ***old_names, Var **rt_env, 
			    int *old_size);
Var 	       *reorder_rt_env(Var *old_rt_env, char **old_names, 
			       int old_size, Program *prog);

#endif

/* $Log: utils.h,v $
 * Revision 1.3  1992/08/10  16:38:28  pjames
 * Added is_true (from execute.h) and *_activ_as_pi routines.
 *
 * Revision 1.2  1992/07/27  18:03:48  pjames
 * Changed name of ct_env to var_names
 *
 * Revision 1.1  1992/07/20  23:23:12  pavel
 * Initial RCS-controlled version.
 * */
